config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: { registrations: 'users/registrations' }
  resources :users do
  	get 'requests', to: 'connection#see_friend_request', as: 'friend_request'
  	post 'accept_request', to: 'connection#accept_request', as: 'accept_request'
  	post 'reject_request', to: 'connection#reject_request', as: 'reject_request'
  end
  root to: 'users#index'
  post 'send_request', to: 'connection#get_friend_request', as: 'new_friend_request'

  resources :posts
  # resources :connections, only: [:new, :create]
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/connection.rb
class Connection < ApplicationRecord
  belongs_to :user
  belongs_to :request, class_name: 'User'

  def self.find_request(id, request_id)
    self.where("user_id = ? and request_id = ?", id, request_id)
  end
end

app/models/post.rb
class Post < ApplicationRecord
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable

  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  has_many :connections, -> { where status: true }
  has_many :friends, through: :connections, source: :request
  has_many :receiving_requests, -> { where status: false }, class_name: 'Connection', foreign_key: 'request_id'
  has_many :requests, through: :receiving_requests, source: :user
  has_many :sent_requests, -> { where status: false }, class_name: 'Connection'
  has_many :pending_sent_requests, through: :sent_requests, source: :request

  has_many :posts


  def all_except
    User.where.not(id: self.id)
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/connection_controller.rb
class ConnectionController < ApplicationController

  before_action :authenticate_user!

  def get_friend_request
    connection = Connection.new(user_id: current_user.id, request_id: params[:id])
    if connection.save
      notice = 'Request sent!'
    else
      notice = 'Request failed, please try again'
    end
    redirect_to(users_path, notice: notice)
  end

  def see_friend_request
    @requests = current_user.requests
  end

  def accept_request
    connection = Connection.find_request(params[:id], current_user.id).first
    if connection.update(status: true) && Connection.create(user_id: current_user.id, request_id: params[:id], status: true)
      notice = 'Request accepted!'
    else
      notice = 'Failed to accept request, please try again'
    end
    redirect_to(users_path, notice: notice)
  end

  def reject_request
    connection = Connection.find_request(params[:id], current_user.id).first
    if connection.destroy
      notice = 'Request rejected!'
    else
      notice = 'Failed to reject request, please try again'
    end
    redirect_to(users_path, notice: notice)
  end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController

  before_action :authenticate_user!

  def index
    @posts = []
    current_user.friends.each do |friend|
      @posts = @posts + friend.posts
    end
    @posts = @posts + current_user.posts
    @posts = @posts.shuffle
  end

  def new
    @post = Post.new
  end

  def create
    @post = current_user.posts.new(post_params)
    if @post.save
      notice = 'Posted!'
    else
      notice = 'Not able to create post, please try again!'
    end
    redirect_to(posts_path, notice: notice)
  end

  def show
    @post = Post.find(params[:id])
  end

  def destroy
    @post = Post.find(params[:id])
    if @post.destroy
      notice = 'Post deleted!'
    else
      notice = 'Not able to delete post, please try again!'
    end
    redirect_to(posts_path, notice: notice)
  end

  def edit
    @post = Post.find(params[:id])
  end

  def update
    @post = Post.find(params[:id])
    if @post.update(post_params)
      notice = 'Post updated!'
    else
      notice = 'Not able to update post, please try again!'
    end
    redirect_to(post_path(@post), notice: notice)
  end

  private

  def post_params
    params.require(:post).permit(:title, :body)
  end
end

app/controllers/users/registrations_controller.rb
# frozen_string_literal: true

class Users::RegistrationsController < Devise::RegistrationsController
  before_action :configure_sign_up_params, only: [:create]
  # before_action :configure_account_update_params, only: [:update]

  # GET /resource/sign_up
  # def new
  #   super
  # end

  # POST /resource
  def create
    super
  end

  # GET /resource/edit
  # def edit
  #   super
  # end

  # PUT /resource
  # def update
  #   super
  # end

  # DELETE /resource
  # def destroy
  #   super
  # end

  # GET /resource/cancel
  # Forces the session data which is usually expired after sign
  # in to be expired now. This is useful if the user wants to
  # cancel oauth signing in/up in the middle of the process,
  # removing all OAuth session data.
  # def cancel
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  def configure_sign_up_params
    devise_parameter_sanitizer.permit(:sign_up, keys: [:name, :username])
  end

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_account_update_params
  #   devise_parameter_sanitizer.permit(:account_update, keys: [:name, :username])
  # end

  # The path used after sign up.
  # def after_sign_up_path_for(resource)
  #   # super(resource)
  #   redirect_to users_path
  # end

  # The path used after sign up for inactive accounts.
  # def after_inactive_sign_up_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :authenticate_user!

  def index
    user = User.find(current_user.id)
    @friends = user.friends
    @pending_invites = user.pending_sent_requests
    @requests = user.requests
    @rest_all_users = user.all_except
    @rest_all_users = @rest_all_users - @requests - @friends - @pending_invites
  end

  def show
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/connection_helper.rb
module ConnectionHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/connection/see_friend_request.html.erb
<h2>Friend Requests</h2>
<ol>
<% @requests.each do |request| %>
<li>
  <p>
    <%= "Incoming request from #{request.name}" %>
  </p>
  <p>
    <%= link_to 'Accept', user_accept_request_path(current_user.id, id: request.id), method: 'post' %>
  </p>
  <p>
    <%= link_to 'Decline', user_reject_request_path(current_user.id, id: request.id), method: 'post' %>
  </p>
</li>
<% end %>
</ol>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TheFacebook</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <p class="flash"><%= flash.notice %></p>
    <% if current_user %>
      <%= link_to 'Sign out', destroy_user_session_path, method: :delete %>
    <% else %>
      <%= link_to 'Sign in', user_session_path %>
      <%= link_to 'Sign up', new_user_registration_path %>
    <% end %>
    <%= yield %>
  </body>
</html>

app/views/posts/_form.html.erb
<%= form_for(@post) do |f| %>
<p>
<%= f.label :title %>
<%= f.text_field :title %>
</p>

<p>
<%= f.label :body %>
<%= f.text_area :body %>
</p>

<p>
<%= f.submit 'Submit!' %>
</p>

<% end %>

app/views/posts/edit.html.erb
<h2>
  Edit the post!
</h2>

<%= render partial: 'form' %>

app/views/posts/index.html.erb
<h2>
  Timeline
</h2>

<%= link_to 'Create a new post!', new_post_path %>

<% @posts.each do |post| %>
<p>
  <%= post.user.name %></br>
  <%= post.title %></br>
  <%= post.body %></br>
  <% if post.user.email.eql?(current_user.email) %>
  <%= link_to 'Edit the post', edit_post_path(post) %></br>
  <%= link_to 'Delete the post', post_path(post), method: :delete, data: { confirm: 'Do you really want to delete the post?' } %>
  <% end %>
</p>
<% end %>

app/views/posts/new.html.erb
<h2>
  Create a new post!
</h2>

<%= render partial: 'form' %>

app/views/posts/show.html.erb
<h3>
  Your post here
</h3>

<p>
<%= "Author of the post is #{@post.user.name}" %>
</p>
<p>
<%= @post.title %>
</p>
<p>
<%= @post.body %>
</p>

app/views/users/index.html.erb
<p>
<%= link_to 'Visit your timeline', posts_path %>
</p>

<ul>
<% @rest_all_users.each do |user| %>
<li>
  <%= user.name %>
  <%= user.username %>
  <%= link_to 'Send friend request', new_friend_request_path(id: user.id), method: 'post'%>
</li>
<% end %>
</ul>

<ul>
<% @pending_invites.each do |user| %>
<li>
  <%= user.name %>
  <%= user.username %>
  <%= 'Request already sent' %>
</li>
<% end %>
</ul>

<ul>
<% @friends.each do |user| %>
<li>
  <%= user.name %>
  <%= user.username %>
</li>
<% end %>
</ul>

<p>
  <%= link_to 'Check all friend requests received', user_friend_request_path(current_user.id) %>
</p>